#pragma once
/**
 * @addtogroup ta_api Threat Arbitrator (TA) API
 * @{
 *
 * The Cohda Threat Arbitrator is used to detect and warn drivers about the
 * following V2V applications:
 *
 * - Forward Collision Warning (FCW)
 * - Emergency Electronic Brake Light (EEBL)
 * - Intersection Collision Warning (ICW) / Intersection Movement Assist
 *   (IMA) Warning.
 *
 * The Cohda TA uses a callback mechanism to notify of alerts
 *
 * @file
 *
 */

//------------------------------------------------------------------------------
// Copyright (c) 2013 Cohda Wireless Pty Ltd
//------------------------------------------------------------------------------

#ifndef __TA_H_
#define __TA_H_

//------------------------------------------------------------------------------
// Included headers
//------------------------------------------------------------------------------

/// Autogenerated header file containing TA error code enumeration
#include "TA_Err.h"

#include "TC.h"
#include "BufferQueue.h"
#include "Vector.h"
#include "conf-ini.h"
#include "lph.h"
#include "vstate.h"

#include <stdbool.h>
#include <stdint.h>

#ifdef __cplusplus
extern "C"
{
#endif

//------------------------------------------------------------------------------
// Macros & Constants
//------------------------------------------------------------------------------

#define TA_MAX_NUM_APPLICATIONS          12
#define MAX_REFERENCE_DENMS               8
#define TA_ALERT_MAX_IVS_SIGNS            4
#define TA_ALERT_IVS_TEXT_LEN            64
#define TA_ALERT_MAX_IHW                  4

//------------------------------------------------------------------------------
// Type definitions
//------------------------------------------------------------------------------

/// Threat Zones, in HDUS, mapped to front,left,right,rear warnings
typedef struct SafetyZone
{
  int16_t SouthWest;
  int16_t NorthWest;
  int16_t NorthEast;
  int16_t SouthEast;
} tSafetyZone;

typedef struct TAParamsFast
{
  float CurveSep_mm;
  float SafeSpeed_MMPNMIN;
  float SineParallelLimit;
  tSafetyZone SafetyZone;

  float SOFTBRAKE_RAIN_mmpnm2;
  float HARDBRAKE_RAIN_mmpnm2;
  float SOFTBRAKE_SNOW_mmpnm2;
  float HARDBRAKE_SNOW_mmpnm2;
  float SOFTBRAKE_DRY_mmpnm2;
  float HARDBRAKE_DRY_mmpnm2;

  float LON_ACCEL_COEFF_NOW;
  float LON_ACCEL_COEFF_OLD;

  float Hysteresis_DTE_mm;
  float Hysteresis_TTE_ms;

  struct timeval tooOld;
  struct timeval tooYoung;
} tTAParamsFast;

typedef struct TAStats
{
  /// TC interfacing
  unsigned NbrTCAdd;
  unsigned NbrTCUpdate;
  unsigned NbrTCPurge;
  unsigned NbrTCConf;
  /// Threat Evaluation
  unsigned NEVALMissingLocal;
  unsigned NEVALAssessments;
  unsigned NEVALNoClassifications;
  unsigned NEVALLocalSlow;
  unsigned NEVALSanityCheckRange;
  unsigned NEVALOperatingRange;
  unsigned NEVALOppositeHeading;
  unsigned NEVALCurveLane;
  unsigned NEVALStraightLane;
  unsigned NEVALRemoteSlow;
  unsigned NEVALCrossingBehind;
  unsigned NEVALFuture;
  unsigned NEVALBehind;
  unsigned NEVALWarnSoft;
  unsigned NEVALWarnHard;
  unsigned NEVALWarnSevere;
} tTAStats;

typedef enum
{
  TA_SIGCOLOR_OFF,
  TA_SIGCOLOR_GREEN,
  TA_SIGCOLOR_YELLOW,
  TA_SIGCOLOR_RED,
} eTALightColorState;

typedef enum
{
  TA_GLOSA_TIME_CHANGE,
  TA_GLOSA_ADV_SPEED,
} eTAGlosaType;

typedef enum
{
  TA_TRAFFIC_DIR_STRAIGHT = 0,
  TA_TRAFFIC_DIR_LEFT,
  TA_TRAFFIC_DIR_RIGHT,
  TA_TRAFFIC_DIR_BALL
} eTALaneDirection;

typedef enum
{
  CSW_DIRECTION_UNKNOWN = 0,
  CSW_DIRECTION_LEFT,
  CSW_DIRECTION_RIGHT
} eCSWDirection;

/// TA severity level
typedef enum TASeverity
{
  /// magic value used to cancel alerts
  TA_SEVERITY_CANCEL   =   0,
  /// minimum valid severity, used for tracking
  TA_SEVERITY_MINIMUM  =   1,
  /// highest severity for tracking
  TA_SEVERITY_TRACKING =  50,
  /// inform driver, safe to ignore (in-vehicle signage)
  TA_SEVERITY_INFORM   = 100,
  /// notify driver, should take heed
  TA_SEVERITY_NOTIFY   = 150,
  /// action required to avoid crash (e.g. braking)
  TA_SEVERITY_WARN     = 200,
  /// emergency action required to avoid crash (e.g. hard brake)
  TA_SEVERITY_ACTION   = 250,
  /// crash inevitable, try to mitigate
  TA_SEVERITY_MITIGATE = 255,
} eTASeverity;

/// @ref eTASeverity;
typedef uint8_t tTASeverity;

/// Please keep @ref TA_ThreatType() aligned with this
typedef enum TAThreatType
{
  TA_THREATTYPE_NONE       = UINT32_C(0),       ///< No alert
  TA_THREATTYPE_RESERVED0  = (UINT32_C(1)<<0),  ///< Reserved (potentially for future use?)
  // V2V EU + NA
  TA_THREATTYPE_FCW        = (UINT32_C(1)<<1),  ///< Forward Collision Warning
  TA_THREATTYPE_ICW        = (UINT32_C(1)<<2),  ///< Intersection Collision Warning
  TA_THREATTYPE_LTA        = (UINT32_C(1)<<3),  ///< Left Turn Assist
  TA_THREATTYPE_BSW_LCW    = (UINT32_C(1)<<4),  ///< Blind-Spot & Lane-Change Warning (also Motorcycle Approaching Warning)
  TA_THREATTYPE_DNPW       = (UINT32_C(1)<<5),  ///< Do not pass warning
  TA_THREATTYPE_IASS       = (UINT32_C(7)<<6),  ///< Intervention of Active Safety Systems
  TA_THREATTYPE_EEBL       = (UINT32_C(1)<<6),  ///< Emergency Electronic Brake Light
  TA_THREATTYPE_AEB        = (UINT32_C(1)<<7),  ///< Automatic Emergency Braking
  TA_THREATTYPE_PCS        = (UINT32_C(1)<<8),  ///< Pre-Crash Systems
  TA_THREATTYPE_HLW        = (UINT32_C(7)<<9),  ///< Hazard location warning
  TA_THREATTYPE_HLW_FOG    = (UINT32_C(1)<<9),  ///< Hazard location warning - Fog/low visibility
  TA_THREATTYPE_HLW_RAIN   = (UINT32_C(1)<<10), ///< Hazard location warning - Rain/Snow
  TA_THREATTYPE_HLW_TRC    = (UINT32_C(1)<<11), ///< Hazard location warning - Low Traction
  TA_THREATTYPE_SVA        = (UINT32_C(7)<<12), ///< Stationary Vehicles Ahead
  TA_THREATTYPE_SVA_AIR    = (UINT32_C(1)<<12), ///< Stationary Vehicles Ahead - Airbag Deployed
  TA_THREATTYPE_SVA_HZR    = (UINT32_C(1)<<13), ///< Stationary Vehicles Ahead - Hazard Lights
  TA_THREATTYPE_SVA_BRK    = (UINT32_C(1)<<14), ///< Stationary Vehicles Ahead - Broken Down
  TA_THREATTYPE_EVW        = (UINT32_C(1)<<15), ///< Emergency Vehicle Warning
  TA_THREATTYPE_EVW_STAT   = (UINT32_C(1)<<16), ///< Emergency Vehicle Warning - Stationary
  TA_THREATTYPE_VTRW       = (UINT32_C(1)<<17), ///< Vehicle Turning Right in Front of Bus Warning (VTRW)

  // V2I (SPAT/MAP)
  TA_THREATTYPE_GLOSA      = (UINT32_C(1)<<18), ///< Green Light Speed Advice
  TA_THREATTYPE_SVW        = (UINT32_C(1)<<19), ///< Signal Violation Warning
  // V2I (SSM/SRM)
  TA_THREATTYPE_RESERVED20 = (UINT32_C(1)<<20), ///< Reserved
  TA_THREATTYPE_SSM_SRM    = (UINT32_C(1)<<20), ///< SSM/SRM
  // V2I (PVD)
  TA_THREATTYPE_RESERVED25 = (UINT32_C(1)<<25), ///< Reserved
  TA_THREATTYPE_PVD        = (UINT32_C(1)<<25), ///< PVD

  TA_THREATTYPE_RESERVED26 = (UINT32_C(1)<<26), ///< Reserved

  // EU DENM
  TA_THREATTYPE_IHW        = (UINT32_C(1)<<21), ///< Infrastructure HLW
  TA_THREATTYPE_IVS        = (UINT32_C(1)<<22), ///< In Vehicle Signage
  TA_THREATTYPE_RWW        = (UINT32_C(1)<<23), ///< Roadwork Warning
  TA_THREATTYPE_TJA        = (UINT32_C(1)<<24), ///< Traffic Jam Ahead

  // V2I (NA TIM & RSA)
  TA_THREATTYPE_RSA        = (UINT32_C(1)<<21), ///< Road Side Alert
  TA_THREATTYPE_CSW        = (UINT32_C(1)<<22), ///< Curve Speed Warning
  TA_THREATTYPE_WZA        = (UINT32_C(1)<<23), ///< Work Zone Alert
  TA_THREATTYPE_OVW        = (UINT32_C(1)<<27), ///< Oversize Vehicle Warning
  TA_THREATTYPE_EVAC       = (UINT32_C(1)<<28), ///< Evacuation
  TA_THREATTYPE_SPEEDLIMIT = (UINT32_C(1)<<29), ///< Speed Limit Warning
  TA_THREATTYPE_GENERICTIM = (UINT32_C(1)<<30), ///< Generic TIM ITIS code matching

  // Customer specific
  TA_THREATTYPE_FDW        = (UINT32_C(1)<<17), ///< Forward Distance Warning
  TA_THREATTYPE_FSP        = (UINT32_C(1)<<20), ///< Freight Signaling Priority messages (request, grant, deny)
  TA_THREATTYPE_FCA        = (UINT32_C(1)<<26), ///< Fault Checking Application
  TA_THREATTYPE_UAVD       = (UINT32_C(1)<<26), ///< DSRC vehicle detected (Authorised/Unauthorised)?

  // Customer defined
  TA_THREATTYPE_CUSTOM0    = (UINT32_C(1)<<30), ///< Custom alert type 0
  TA_THREATTYPE_CUSTOM1    = (UINT32_C(1)<<31), ///< Custom alert type 1
} tTAThreatType;

/// Bit-mask of above threat flags. Make sure they all fit!
/// @ref tTAThreatType
typedef uint32_t tTAThreatTypes;

/// Additional information to keep with Remote data.
/// The intention is that third-party TA's can maintain housekeeping data
/// which will be managed by the TC.
typedef struct TARemote
{
  /// Maximum threat level posed by this remote.
  uint8_t Level;
  /// Threats this remote is currently posing.
  tTAThreatTypes Threats;
  /// Previous alerts, and flag if the latest evaluation caused a delta
  tTAThreatType PrevTAThreats;
  bool AlertDelta;
  /// Previous control flags, and if the latest evaluation caused a delta
  tTCControlFlags  PrevTCControlFlags;
  bool ControlDelta;
  /// Filtered longitudinal acceleration
  float FiltLonAccel_mmpnmin2;
  ///
  struct timeval LastBrakeOff;
  // Scratchpad for apps.
  size_t ScratchpadSize;
  uint8_t Scratchpad[0];
} tTARemote;


/// per-sign information for in-vehicla-signage alerts
/// memset(-1) to inidcate "unused"
typedef struct TAAlert_IVS_Sign
{
  /// EventDirection.  0 = Ahead, 1 = Behind.
  int8_t IVSDirection;
  /// Distance to the IVS event position. -1 if unknown
  int32_t Distance2IVS_mm; // strictly per zone rather than per sign...
  /// Distance to the end of the IVS.  -1 if unknown
  int32_t Distance2EndIVS_mm;


  /// @note Please refer  http://standards.iso.org/iso/ts/14823/ for these codes
  /// 11 Warning, 12 Regulatory, 13 Guide, 21 Pub Facilities, 3x Ambient or Road Conditions
  /// first digit is ITSISO14823Code_4_choice
  /// second digit is one of ITSISO14823Code_1, ITSISO14823Code_2,  ITSISO14823Code_3
  /// (+1, 1-based rather than 0-based)
  uint8_t ServiceCategory;
  /// first digit is 'nature' field of ITSISO14823Code_5
  /// last 2 digits are 'serialNumber' field of ITSISO14823Code_5
  uint16_t PictogramCategory;

  /// Additional Data, e.g. speed limit value.
  int     Value;
  /// units of above value, ITSRSCUnit
  uint8_t Unit;

  /// Applicable Lanes
  uint16_t ApplicableLanes;

  /// Applicable Lanes Count
  uint8_t ApplicableLanesCount;
  /// Applicable Lanes List
  uint8_t ApplLanesList[8];

  /// ExtraText
  char ExtraText[TA_ALERT_IVS_TEXT_LEN];
} tTAAlert_IVS_Sign;


typedef struct TAAlert_IHW
{
  // ID of the DENM that generated this alert
  uint64_t ID;

  /// Distance to the IHW event position. -1 if unknown
  int32_t Distance2IHW_mm;
  /// Distance to the end of the IHW.  -1 if unknown
  int32_t Distance2EndIHW_mm;

  /// uses the ASN.1 codes.
  /// ITSCauseCodeType
  int CauseCode;
  /// ITSSubCauseCodeType
  int SubCauseCode;
} tTAAlert_IHW;

typedef enum TAAlert_WZAType
{
  TA_WZA_NONE = 0,
  TA_WZA_WORK_ZONE_AHEAD = 1,
  TA_WZA_WORK_ZONE_AHEAD_REDUCE_SPEED = 2,
  TA_WZA_EXCESSIVE_SPEED = 3,
} tTAAlert_WZAType;

/// HV information in Alert
typedef struct TAAlert_HV
{
  /// Position/Speed/Heading/Acceleration/Radius
  tVector Vector;
} tTAAlert_HV;

/// RV information in Alert
typedef struct TAAlert_RV
{
  /// Position/Speed/Heading/Acceleration/Radius
  tVector Vector;
  /// Classification of the remote
  tTCClassif Classification;
} tTAAlert_RV;

// Structure for notifying of threats via callback
typedef struct TAAlert
{
  /// The packet that caused this alert to be raised (i.e. the one that
  /// needs to be cryptographically verified befor the HMI is notified)
  tExtMessage *pLastOTA;
  /// The last packet with a full cert (may be the same as pLastOTA)
  tExtMessage *pLastCert;

  /// Keep relative bearing for later potential alert
  tHDU  Azimuth;

  /// HV snapshot when a V2V or V2I alert is reported
  tTAAlert_HV HV;
  /// RV snapshot when a V2V alert is reported
  tTAAlert_RV RV;

  /** Alert ID. See @ref fTA_ThreatApplciation and
   *  @ref fTA_NonRVThreatApplication for how to set it up
   */
  uint64_t ID;
  /// Type of threat. Set by registered TA Applications
  tTAThreatType Type;
  /// Threat Severity Level. Set by registered TA Applications
  tTASeverity Level;
  /// Time to event in seconds (if known/relevant, or NAN).
  /// Set by registered TA Applications
  float TimeToEvent_s;
  /// Distance to event in meters (if known/relevant, or NAN)
  /// Set by registered TA Applications
  float DistanceToEvent_m;

  /// Alert-specific data. Set by registered TA Applications
  union
  {
    /// Emergency Electronic Brake Light
    /// Type == TA_THREATTYPE_EEBL
    struct
    {
      int Level;
    } EEBL;
    /// Type == TA_THREATTYPE_IHW
    struct
    {
      uint8_t AlertCount;
      tTAAlert_IHW Alerts[TA_ALERT_MAX_IHW];
    } IHW;
    /// Type == TA_THREATTYPE_HLW_TRC
    struct
    {
      /// HLW_TRC Scenario type. Set by HLW App
      enum {
        TA_HLW_TRC_SCENARIO_NONE = 0x0,
        /// Antilock-breaking active
        TA_HLW_TRC_SCENARIO_ABS  = 0x1,
        /// Traction-control active
        TA_HLW_TRC_SCENARIO_TRC  = 0x2,
        /// Stability-control active
        TA_HLW_TRC_SCENARIO_SCA  = 0x4,
      } Scenario;
    } HLW_TRC;
    /// Forward Collision Warning
    /// Type == TA_THREATTYPE_FCW
    struct
    {
      char dummy_to_keep_vs_happy;
    } FCW;
    /// Forward Distance Warning
    /// Type == TA_THREATTYPE_FDW
    struct
    {
      char dummy_to_keep_vs_happy;
    } FDW;
    /// Fault Checking Application
    /// Type == TA_THREATTYPE_FCA
    struct
    {
      char dummy_to_keep_vs_happy;
    } FCA;
    /// Type == TA_THREATTYPE_UAVD
    struct
    {
      uint16_t VehCertID; ///CertID of the authorised vehicle (Upper 16bit information)
    } UAVD;
    /// Intersection Collision Warning
    /// Type == TA_THREATTYPE_ICW
    struct
    {
      /// ICW Scenario type. Set by ICW App
      enum {
        TA_ICW_SCENARIO_ICW,
        TA_ICW_SCENARIO_IMA
      } Scenario;
      tHDU ThreatBearing;
      tSafetyZone SafetyZone;
    } ICW;
    /// Type == TA_THREATTYPE_LTA
    struct
    {
      char dummy_to_keep_vs_happy;
    } LTA;
    /// Type == TA_THREATTYPE_BSW_LCW
    struct
    {
      /// BSW_LCW Scenario type. Set by BSW_LCW App
      enum {
        TA_BSW_LCW_SCENARIO_BSW,
        TA_BSW_LCW_SCENARIO_LCW
      } Scenario;
    } BSW_LCW;
    /// Curve Speed Warning
    /// Type == TA_THREATTYPE_CSW
    struct
    {
      /// Direction of CSW (left/right) - see ITIS code
      uint16_t AlertDirection;
      /// Speed Limit (km/h)
      uint16_t SpeedLimit;
      /// Region of the Vehicle in the CSW path
      uint8_t Region;
    } CSW;
    /// Speed Limit Warning
    /// Type == TA_THREATTYPE_SPEEDLIMIT
    struct
    {
      /// Speed Limit (km/h)
      uint16_t SpeedLimit;
      /// Region of the Vehicle in the Speed Limit path
      uint8_t Region;
    } SpeedLimit;
    /// Generic TIM ITIS code match
    /// Type == TA_THREATTYPE_GENERICTIM
    struct
    {
      /// ITISCode
      int ITISCode;
    } GenericTIM;
    /// Road Work Warning
    /// Type == TA_THREATTYPE_RWW
    struct
    {
      /// ActionID of the RWW
      uint64_t EventId;
      /// Time of the RWW alert - UTC
      uint64_t AlertTime_ms;
      /// EventDirection.  0 = Ahead, 1 = Behind
      int8_t RWWDirection;
      /// Distance to the RWW event position. -1 if unknown
      int32_t Distance2RWW_mm;
      /// Distance to the end of the RWW.  -1 if unknown
      int32_t Distance2EndRWW_mm;
      /// Is the RWW mobile (moving). -1 if unknown
      int8_t IsMobile;
      /// Hard shoulder status. -1 if unknown
      int8_t HardShoulderStatus;
      /// Number of Lanes. -1 if unknown
      int8_t NumberOfLanes;
      /// Closed Lanes (bitwise indication). -1 if unknown
      int16_t ClosedLanes;
      /// Is the Speed Limit Applicable
      uint8_t SpeedLimitApplicable;
      /// SpeedLimit (km/h). -1 if unknown
      int16_t SpeedLimit_kmph;
      /// TrafficFlowRule. -1 if unknown
      int8_t TrafficFlowRule;
      /// Reference events - related RWW events
      uint64_t ReferenceEvents[MAX_REFERENCE_DENMS];
    } RWW;
    /// Green Light Optimized Speed Advise (GLOSA)
    /// Type == TA_THREATTYPE_GLOSA
    struct
    {
      /// Current type of GLOSA @ref eTAGlosaType
      uint8_t AlertType;
      /// Current signal state @ref eTALightColorState
      uint8_t CurrentPhase;
      /// Signal state upon vehicle arrival @ref eTALightColorState
      uint8_t PhaseAtArrival;
      /// Direction to which this phase applies @ref eTALaneDirection
      uint8_t ValidDirection;
      /// (0 Vertical, 1 Horizontal)
      uint8_t Mounting;
      /// Turn warning
      bool CrossingWarn;
      /// Time to current signal change (1/10'th seconds)
      int TimeChange_ds;
      /// Lane id, ID from MAP of intersection
      int LaneId;
      /// Stop line latitude (deg)
      double StopLineLat_deg;
      /// Stop line longitude (deg)
      double StopLineLon_deg;

      /// Current HV speed
      float CurSpeed_mps;
      /// Calculated advised speed, (m/s)
      float AdvSpeed_mps;
      /// Calculated advised acceleration (m/s^2)
      float AdvAccel_mps2;
    } GLOSA;
    /// Signal Violation Warning (SVW)
    /// Type == TA_THREATTYPE_SVW
    struct
    {
      /// Current signal state @ref eTALightColorState
      uint8_t CurrentPhase;
      /// Signal state upon vehicle arrival @ref eTALightColorState
      uint8_t PhaseAtArrival;
      /// Direction to which this phase applies @ref eTALaneDirection
      uint8_t ValidDirection;
      /// Time to current signal change (1/10'th seconds)
      int TimeChange_ds;
      /// Lane id, ID from MAP of intersection
      int LaneId;
      /// Stop line latitude (deg)
      double StopLineLat_deg;
      /// Stop line longitude (deg)
      double StopLineLon_deg;
    } SVW;
    /// In Vehicle Signage
    /// Type == TA_THREATTYPE_IVS
    struct
    {
      /// ID of the IVS station
      uint32_t StationId;
      /// Time of the IVS alert - UTC
      uint64_t ReferenceTime_ms;
      /// Sign Country Code. From iso14823
      uint8_t CountryCode[2];

      /// signs
      tTAAlert_IVS_Sign Signs[TA_ALERT_MAX_IVS_SIGNS];
      char Text[TA_ALERT_IVS_TEXT_LEN];
    } IVS;
    /// Road Side Alert
    /// Type == TA_THREATTYPE_RSA
    struct
    {
      /// ITISCode
      int EventTypeITIS;
    } RSA;
    /// Work Zone Alert
    /// Type == TA_THREATTYPE_WZA
    struct
    {
      /// Type of Work Zone Alert
      tTAAlert_WZAType WZAType;
      /// Speed Limit (kilometres per hour)
      uint16_t SpeedLimit_kph;
    } WZA;
    /// Oversize Vehicle Warning
    /// Type == TA_THREATTYPE_OVW
    struct
    {
      float ClearanceHeight_m;
      float DistanceToCrash_m;
    } OVW;
    /// Evacuation
    /// Type == TA_THREATTYPE_EVAC
    struct
    {
      /// ITISCode
      int EventTypeITIS;
    } EVAC;
    /// Type == TA_THREATTYPE_VTRW
    struct
    {
      tTCClassif Classification;
      char dummy_to_keep_vs_happy;
    } VTRW;
  };
} tTAAlert;

struct TA;
struct TCRemote;

typedef struct TA_HV
{
  const tVector      *pVector;
  const tVStateState *pVState;
  const tLPHPP       *pLPHPP;
  const tLPHPH       *pLPHPH;
  /// Local position in integer units, useful for ADR
  const tLPHPos      *pLPHPos;
  /// MAP state
  struct {
    void *pAbs; ///< May be NULL
  } Map;
} tTA_HV;

typedef struct TA_RV
{
  const struct TCRemote *pTCRemote;
  tTARemote             *pTARemote;
  /// MAP state
  struct {
    void *pAbs; ///< May be NULL
    void *pRel; ///< May be NULL
  } Map;
} tTA_RV;

/**
 * @brief Assess an RV
 * This function is provided by the Application to evaluate a given Remote
 * Vehicle for a given threat. The current Host and Remote vehicle information
 * is passed in, as well as an alert to fill in (in case there's an alert) and a
 * copy of the current alert (in case it is no longer relevant and needs to be
 * cancelled).
 *
 * To report an alert, set up Type/Level/TimeToEvent_s/DistanceToEvent_m and alert-specific
 * fields in pAlert. Other fields in pAlert are set up by TA automatically.
 *
 * @param[in] pHV Data for the HV
 * @param[in] pRV Data for the RV under consideration
 * @param[out] pAlert RV alert state (modifed by this func)
 * @param[in] pCurrentAlert Current TA alert state (i.e. what the HMI is currently displaying)
 * @param[in,out] pPriv Provided to TA_RegisterApplication()
 * @param[in,out] pScratchpad Per-remote scratchpad for the registered application
 */
typedef void (fTA_ThreatApplication)(const tTA_HV *pHV,
                                     const tTA_RV *pRV,
                                     tTAAlert *pAlert,
                                     const tTAAlert *pCurrentAlert,
                                     void *pPriv,
                                     void *pScratchpad);

typedef void (fTA_ScratchpadInit)(void *pScratchpad);
typedef void (fTA_ScratchpadDeInit)(void *pScratchpad);


/**
 * @brief Assess a non-RV Threat (RWW, GLOSA etc.)
 *
 * This function is provided by the Application to evaluate a given threat that is
 * independant of Remote Vehicles. See @ref fTA_ThreatApplication.
 *
 * @param[in] pHV Data for the HV
 * @param[out] pAlert RV alert state (modifed by this func)
 * @param[in] pCurrentAlert Current TA alert state (i.e. what the HMI is currently displaying)
 * @param[in,out] pPriv Provided to TA_RegisterApplication()
 */
typedef void (fTA_NonRVThreatApplication)(const tTA_HV *pHV,
                                          tTAAlert *pAlert,
                                          const tTAAlert *pCurrentAlert,
                                          void *pPriv);

/**
 * @brief Handle updated configuration
 * @param[in] pIniFile Parsed configuration data
 * @param[in,out] pPriv Provided to TA_RegisterApplication()
 */
typedef void (fTA_ConfigUpdated)(const tdefault_stack *pIniFile,
                                 void *pPriv);

/**
 * @brief Helper struct to keep track of threat apps
 */
typedef struct TA_Application
{
  tTASeverity MaxLevel;
  fTA_ThreatApplication *pFunc;
  void *pPriv;
  fTA_ConfigUpdated *pConf;
  const char * pTag;
  // scratchpad management
  fTA_ScratchpadInit   * pInit;
  fTA_ScratchpadDeInit * pDeInit;
  ssize_t ScratchpadIdx;
} tTA_Application;

/**
 * @brief Helper struct to keep track of non-RV threat apps
 */
typedef struct TA_NonRVApplication
{
  tTASeverity MaxLevel;
  fTA_NonRVThreatApplication *pFunc;
  void *pPriv;
  fTA_ConfigUpdated *pConf;
  const char * pTag;
} tTA_NonRVApplication;

/// Function prototype for user notification of alerts
/// @note: This function can be called from the EXT thread
/// and simultaneously from the periodic reprocessig thread.
/// It must be reentrant and it must be fast.
typedef void (fTA_Callback) (const tTAAlert *pAlert,
                             void *pData);

/// A function you can call to obtain the current alert
typedef bool (fTA_CurrentAlert)(tTAAlert *pAlert,
                                void *pData);

typedef struct TAParams
{
  /// Parameters as read from the conf file
  tCohda_TA Raw;
  /// Parameters converted to speed up processing
  tTAParamsFast Fast;
} tTAParams;

/// State information for TA
typedef struct TA
{
  /// TC registration handle
  unsigned ClientID;

  /// Callback for alert notification
  struct
  {
    fTA_Callback *pFunc;
    void *pPriv;
  } Alert;

  /// Callback to obtain the current alert
  struct
  {
    fTA_CurrentAlert *pFunc;
    void *pPriv;
  } CurrentAlert;
  bool ThreadStarted;
  bool TrigThreadStarted;
  pthread_t ThreadID;
  pthread_mutex_t TALock;
  pthread_mutex_t TANonRVLock;
  bool StopThread;

  tTAParams Params;

  /// Minimum Threat level for periodic processing
  uint8_t MinLevel;

  tTAStats Stats;

  /// Number of registered threat applications
  unsigned NbrApps;
  /// RV threat applications
  tTA_Application Apps[TA_MAX_NUM_APPLICATIONS];

  /// Number of registered non-RV threat applications
  unsigned NbrAppsNonRV;
  // nonRV threat applications
  tTA_NonRVApplication AppsNonRV[TA_MAX_NUM_APPLICATIONS];

  // LPH reader handle
  void *pLPH;
  // VState reader handle for periodic processing
  tUtilBufferQueueReader *vstate_p;
  // VState reader handle for EXT messages
  tUtilBufferQueueReader *vstate_x;

  // how large a scratchpad to allocate
  size_t ScratchpadSize;
} tTA;


//------------------------------------------------------------------------------
// Function Prototypes
//------------------------------------------------------------------------------

void TA_SetDefaultParams(tCohda_TA *pParams);

tTA_ErrCode TA_Init(const tCohda_TA *pParams,
                    fTA_Callback Callback,
                    void *pCallbackPriv,
                    fTA_CurrentAlert *pCurrentFunc,
                    void *pCurrentPriv);

tTA_ErrCode TA_Exit(void);

const tTAStats *TA_Stats(bool Reset);

tTA_ErrCode TA_RegisterApplication(fTA_ThreatApplication *pApp,
                                   tTASeverity MaxLevel,
                                   void *pPriv,
                                   fTA_ConfigUpdated *pConf,
                                   const char * pTag,
                                   fTA_ScratchpadInit   * pInit,
                                   fTA_ScratchpadDeInit * pDeInit,
                                   size_t ScratchpadSize);

tTA_ErrCode TA_RegisterNonRVApplication(fTA_NonRVThreatApplication *pApp,
                                        tTASeverity MaxLevel,
                                        void *pPriv,
                                        fTA_ConfigUpdated *pConf,
                                        const char * pTag);

tTA_ErrCode TA_DeregisterApplication(fTA_ThreatApplication *pApp,
                                     tTASeverity MaxLevel);

tTA_ErrCode TA_DeregisterNonRVApplication(fTA_NonRVThreatApplication *pApp,
                                          tTASeverity MaxLevel);

void TA_SetThreat(tTAThreatTypes *pThreats,
                  tTAThreatTypes Mask,
                  uint64_t Id,
                  const char *Tag);

void TA_ClearThreat(tTAThreatTypes *pThreats,
                    tTAThreatTypes Mask,
                    uint64_t Id,
                    const char *Tag);

void TA_ReportAlert(const tTAAlert *pTAAlert);
void TA_CancelAlert(const tTAAlert *pTAAlert);

bool TA_IsCutoffExpired(const struct timeval *Now,
                        struct timeval *Cutoff,
                        const struct timeval *CutoffDuration);

const char *TA_ThreatType(tTAThreatType Type);

const tTAParams *TA_Params(void);

void TA_AdjustDistanceTime(bool Alerting,
                           float *MaxRange_mm,
                           float *MaxTime_ms);

void TA_UpdateDistForAlertCancellation(tTAAlert     *pTAAlert,
                                       const tTAAlert *pCurrentAlert,
                                       const tTA_RV *pRv);

#ifdef __cplusplus
}
#endif

#endif // __TA_H_

// Close the doxygen group
/**
 * @}
 */
